

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.data.db.mssql &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../../index.html"/>
        <link rel="up" title="Module code" href="../../../index.html"/> 

  
  <script src="../../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.data.db.mssql</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.data.db.mssql</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="kn">from</span> <span class="nn">d2o.utils</span> <span class="kn">import</span> <span class="n">putils</span> <span class="k">as</span> <span class="n">put</span>
<span class="kn">from</span> <span class="nn">d2o.utils</span> <span class="kn">import</span> <span class="n">logger</span> <span class="k">as</span> <span class="n">log</span>
<span class="kn">from</span> <span class="nn">d2o.utils.timeout</span> <span class="kn">import</span> <span class="n">timeout</span>
<span class="kn">from</span> <span class="nn">d2o.utils.handlers</span> <span class="kn">import</span> <span class="n">ExceptionHandler</span>

<span class="kn">import</span> <span class="nn">sqlalchemy</span> <span class="kn">as</span> <span class="nn">sqla</span>
<span class="kn">from</span> <span class="nn">sqlalchemy.orm</span> <span class="kn">import</span> <span class="n">sessionmaker</span>
<span class="kn">import</span> <span class="nn">pyodbc</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">decimal</span>
<span class="kn">import</span> <span class="nn">datetime</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="kn">as</span> <span class="nn">pd</span>

<span class="kn">from</span> <span class="nn">IPy</span> <span class="kn">import</span> <span class="n">IP</span>

<div class="viewcode-block" id="valid_ip"><a class="viewcode-back" href="../../../../d2o.data.db.html#d2o.data.db.mssql.valid_ip">[docs]</a><span class="k">def</span> <span class="nf">valid_ip</span><span class="p">(</span><span class="n">s</span><span class="p">):</span>
  <span class="sd">&quot;&quot;&quot; Simple check to see if the string s is a valid IP</span>

<span class="sd">  :param s: IP, string</span>
<span class="sd">  :returns:     True if valid, False otherwise</span>
<span class="sd">  &quot;&quot;&quot;</span>
  <span class="k">try</span><span class="p">:</span>
    <span class="n">IP</span><span class="p">(</span><span class="n">s</span><span class="p">)</span>
    <span class="k">return</span> <span class="bp">True</span>
  <span class="k">except</span><span class="p">:</span>
    <span class="k">return</span> <span class="bp">False</span></div>

<div class="viewcode-block" id="MSSQL"><a class="viewcode-back" href="../../../../d2o.data.db.html#d2o.data.db.mssql.MSSQL">[docs]</a><span class="k">class</span> <span class="nc">MSSQL</span><span class="p">:</span>
  <span class="sd">&quot;&quot;&quot; Database connection via SQLAlchemy to Microsoft SQL Server &quot;&quot;&quot;</span>
  <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">user</span><span class="p">,</span> <span class="n">password</span><span class="p">,</span> <span class="n">host</span><span class="p">,</span> <span class="n">database</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">driver</span><span class="o">=</span><span class="s1">&#39;FreeTDS&#39;</span><span class="p">):</span>
    <span class="n">host_is_ip</span> <span class="o">=</span> <span class="n">valid_ip</span><span class="p">(</span><span class="n">host</span><span class="p">)</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">user</span> <span class="o">=</span> <span class="n">user</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">password</span> <span class="o">=</span> <span class="n">password</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">host</span> <span class="o">=</span> <span class="n">host</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">database</span> <span class="o">=</span> <span class="n">database</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">driver</span> <span class="o">=</span> <span class="n">driver</span>

    <span class="c1"># TODO Check for windows -&gt; driver = &#39;SQL Server&#39;</span>
    <span class="n">connection_string</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">host_is_ip</span><span class="p">):</span>
      <span class="n">connection_string</span> <span class="o">=</span> <span class="s1">&#39;mssql+pymssql://</span><span class="si">%s</span><span class="s1">:</span><span class="si">%s</span><span class="s1">@</span><span class="si">%s</span><span class="s1">:1433/</span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">user</span><span class="p">,</span><span class="n">password</span><span class="p">,</span><span class="n">host</span><span class="p">,</span><span class="n">database</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
      <span class="n">connection_string</span> <span class="o">=</span> <span class="s1">&#39;mssql+pyodbc://</span><span class="si">%s</span><span class="s1">:</span><span class="si">%s</span><span class="s1">@</span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">user</span><span class="p">,</span><span class="n">password</span><span class="p">,</span><span class="n">host</span><span class="p">)</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">engine</span> <span class="o">=</span> <span class="n">sqla</span><span class="o">.</span><span class="n">create_engine</span><span class="p">(</span><span class="n">connection_string</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;utf-8&#39;</span><span class="p">,</span> <span class="n">pool_timeout</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">connect_args</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;timeout&#39;</span><span class="p">:</span><span class="mi">5</span><span class="p">})</span>

<div class="viewcode-block" id="MSSQL.pyodbc_connection"><a class="viewcode-back" href="../../../../d2o.data.db.html#d2o.data.db.mssql.MSSQL.pyodbc_connection">[docs]</a>  <span class="k">def</span> <span class="nf">pyodbc_connection</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Create and return a pure (non-sqla) pyodbc connection</span>
<span class="sd">    :returns:       pyodbc connection</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">connection_string</span> <span class="o">=</span> <span class="s1">&#39;DRIVER=</span><span class="si">%s</span><span class="s1">;SERVER=</span><span class="si">%s</span><span class="s1">;PORT=1433;DATABASE=</span><span class="si">%s</span><span class="s1">;UID=</span><span class="si">%s</span><span class="s1">;PWD=</span><span class="si">%s</span><span class="s1">;TDS_Version=8.0;&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">driver</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">host</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">database</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">user</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">password</span><span class="p">)</span>
    <span class="k">try</span><span class="p">:</span>
      <span class="k">return</span> <span class="n">pyodbc</span><span class="o">.</span><span class="n">connect</span><span class="p">(</span><span class="n">connection_string</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
      <span class="n">log</span><span class="o">.</span><span class="n">err</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">ExceptionHandler</span><span class="p">(</span><span class="n">e</span><span class="p">))</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2"> Make sure you&#39;re connecting using IP and not DSN&quot;</span><span class="p">)</span></div>

  <span class="nd">@timeout</span><span class="p">(</span><span class="mi">5</span><span class="p">)</span>
<div class="viewcode-block" id="MSSQL.is_connected"><a class="viewcode-back" href="../../../../d2o.data.db.html#d2o.data.db.mssql.MSSQL.is_connected">[docs]</a>  <span class="k">def</span> <span class="nf">is_connected</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Check if connection is established</span>
<span class="sd">    :returns:       True if connected, False otherwise</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
      <span class="n">connection</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">engine</span><span class="o">.</span><span class="n">raw_connection</span><span class="p">()</span>
      <span class="n">cursor</span> <span class="o">=</span> <span class="n">connection</span><span class="o">.</span><span class="n">cursor</span><span class="p">()</span>
      <span class="n">cursor</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
      <span class="n">connection</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
      <span class="n">connection</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
      <span class="k">return</span> <span class="bp">True</span>
    <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
      <span class="n">log</span><span class="o">.</span><span class="n">err</span><span class="p">(</span><span class="n">ExceptionHandler</span><span class="p">(</span><span class="n">e</span><span class="p">))</span>
      <span class="k">return</span> <span class="bp">False</span></div>

<div class="viewcode-block" id="MSSQL.execute"><a class="viewcode-back" href="../../../../d2o.data.db.html#d2o.data.db.mssql.MSSQL.execute">[docs]</a>  <span class="k">def</span> <span class="nf">execute</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">query</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Run query on server.</span>
<span class="sd">    :param query: Query string</span>
<span class="sd">    :returns:       None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">engine</span><span class="o">.</span><span class="n">execute</span><span class="p">(</span><span class="n">query</span><span class="p">)</span>
    <span class="k">except</span><span class="p">:</span>
      <span class="k">raise</span></div>

<div class="viewcode-block" id="MSSQL.select"><a class="viewcode-back" href="../../../../d2o.data.db.html#d2o.data.db.mssql.MSSQL.select">[docs]</a>  <span class="k">def</span> <span class="nf">select</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">query</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Run SELECT query on server.</span>
<span class="sd">    :param query: Query string</span>
<span class="sd">    :returns:       SQLAlchemy result set</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
      <span class="n">result</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">engine</span><span class="o">.</span><span class="n">execute</span><span class="p">(</span><span class="n">query</span><span class="p">)</span>
      <span class="k">return</span> <span class="n">result</span>
    <span class="k">except</span><span class="p">:</span>
      <span class="k">raise</span></div>

<div class="viewcode-block" id="MSSQL.execute_raw"><a class="viewcode-back" href="../../../../d2o.data.db.html#d2o.data.db.mssql.MSSQL.execute_raw">[docs]</a>  <span class="k">def</span> <span class="nf">execute_raw</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">query</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Open up a direct connection to the db via the current engine and run query.</span>
<span class="sd">    :param query: Query string</span>
<span class="sd">    :returns:       None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
      <span class="n">connection</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">engine</span><span class="o">.</span><span class="n">raw_connection</span><span class="p">()</span>
      <span class="n">cursor</span> <span class="o">=</span> <span class="n">connection</span><span class="o">.</span><span class="n">cursor</span><span class="p">()</span>
      <span class="n">cursor</span><span class="o">.</span><span class="n">execute</span><span class="p">(</span><span class="n">query</span><span class="p">)</span>
      <span class="n">cursor</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
      <span class="n">connection</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
    <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
      <span class="n">log</span><span class="o">.</span><span class="n">err</span><span class="p">(</span><span class="n">ExceptionHandler</span><span class="p">(</span><span class="n">e</span><span class="p">))</span>
    <span class="k">finally</span><span class="p">:</span>
      <span class="n">connection</span><span class="o">.</span><span class="n">close</span><span class="p">()</span></div>

<div class="viewcode-block" id="MSSQL.select_raw"><a class="viewcode-back" href="../../../../d2o.data.db.html#d2o.data.db.mssql.MSSQL.select_raw">[docs]</a>  <span class="k">def</span> <span class="nf">select_raw</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">query</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Open up a direct connection to the db via the current engine and run SELECT query.</span>
<span class="sd">    :param query: Query string</span>
<span class="sd">    :returns:       SQLAlchemy result set</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">results</span> <span class="o">=</span> <span class="bp">None</span>
    <span class="k">try</span><span class="p">:</span>
      <span class="n">connection</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">engine</span><span class="o">.</span><span class="n">raw_connection</span><span class="p">()</span>
      <span class="n">cursor</span> <span class="o">=</span> <span class="n">connection</span><span class="o">.</span><span class="n">cursor</span><span class="p">()</span>
      <span class="n">cursor</span><span class="o">.</span><span class="n">execute</span><span class="p">(</span><span class="n">query</span><span class="p">)</span>
      <span class="n">results</span> <span class="o">=</span> <span class="n">cursor</span><span class="o">.</span><span class="n">fetchall</span><span class="p">()</span>
      <span class="n">cursor</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
      <span class="n">connection</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
    <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
      <span class="n">log</span><span class="o">.</span><span class="n">err</span><span class="p">(</span><span class="n">ExceptionHandler</span><span class="p">(</span><span class="n">e</span><span class="p">))</span>
    <span class="k">finally</span><span class="p">:</span>
      <span class="n">connection</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
    <span class="n">log</span><span class="o">.</span><span class="n">dbg</span><span class="p">(</span><span class="s2">&quot;RESULT:</span><span class="se">\n</span><span class="s2"> </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">results</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">results</span></div>

<div class="viewcode-block" id="MSSQL.select_df"><a class="viewcode-back" href="../../../../d2o.data.db.html#d2o.data.db.mssql.MSSQL.select_df">[docs]</a>  <span class="k">def</span> <span class="nf">select_df</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">query</span><span class="p">,</span> <span class="n">index_col</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">parse_dates</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Select data, store and return data as a Pandas dataframe.</span>
<span class="sd">    :param query: Query string</span>
<span class="sd">    :param index_col: Index column</span>
<span class="sd">    :param parse_dates: List of columns which contain dates</span>
<span class="sd">    :returns:       Pandas dataframe</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_sql</span><span class="p">(</span><span class="n">query</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">engine</span><span class="p">,</span> <span class="n">index_col</span><span class="o">=</span><span class="n">index_col</span><span class="p">,</span> <span class="n">parse_dates</span><span class="o">=</span><span class="n">parse_dates</span><span class="p">)</span>
    <span class="n">log</span><span class="o">.</span><span class="n">dbg</span><span class="p">(</span><span class="s2">&quot;RESULT df:</span><span class="se">\n</span><span class="s2"> </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">df</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">df</span></div>
    <span class="c1"># df = None</span>
    <span class="c1"># try:</span>
    <span class="c1">#   connection = self.engine.raw_connection()</span>
    <span class="c1">#   cursor = connection.cursor()</span>
    <span class="c1">#   cursor.execute(query)</span>
    <span class="c1">#   df = self.__processCursor(cursor, index_col=index_col)</span>
    <span class="c1"># finally:</span>
    <span class="c1">#   connection.close()</span>
    <span class="c1"># return df</span>

  <span class="k">def</span> <span class="nf">__processCursor</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cur</span><span class="p">,</span> <span class="n">index_col</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="n">datatypes</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">colinfo</span> <span class="o">=</span> <span class="n">cur</span><span class="o">.</span><span class="n">description</span>
    <span class="k">for</span> <span class="n">col</span> <span class="ow">in</span> <span class="n">colinfo</span><span class="p">:</span>
      <span class="k">if</span> <span class="n">col</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="nb">unicode</span><span class="p">:</span>
        <span class="n">datatypes</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">col</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="s1">&#39;U</span><span class="si">%d</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="n">col</span><span class="p">[</span><span class="mi">3</span><span class="p">]))</span>
      <span class="k">elif</span> <span class="n">col</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="nb">str</span><span class="p">:</span>
        <span class="n">datatypes</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">col</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="s1">&#39;S</span><span class="si">%d</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="n">col</span><span class="p">[</span><span class="mi">3</span><span class="p">]))</span>
      <span class="k">elif</span> <span class="n">col</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="ow">in</span> <span class="p">[</span><span class="nb">float</span><span class="p">,</span> <span class="n">decimal</span><span class="o">.</span><span class="n">Decimal</span><span class="p">]:</span>
        <span class="n">datatypes</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">col</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="s1">&#39;f4&#39;</span><span class="p">))</span>
      <span class="k">elif</span> <span class="n">col</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="n">datetime</span><span class="o">.</span><span class="n">datetime</span><span class="p">:</span>
        <span class="n">datatypes</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">col</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="s1">&#39;O4&#39;</span><span class="p">))</span>
      <span class="k">elif</span> <span class="n">col</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="nb">int</span><span class="p">:</span>
        <span class="n">datatypes</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">col</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="s1">&#39;i4&#39;</span><span class="p">))</span>

    <span class="n">data</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">row</span> <span class="ow">in</span> <span class="n">cur</span><span class="p">:</span>
      <span class="n">data</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="nb">tuple</span><span class="p">(</span><span class="n">row</span><span class="p">))</span>

    <span class="n">array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">data</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">datatypes</span><span class="p">)</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">from_records</span><span class="p">(</span><span class="n">array</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">index_col</span> <span class="ow">is</span> <span class="ow">not</span> <span class="bp">None</span><span class="p">:</span>
      <span class="n">df</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">set_index</span><span class="p">(</span><span class="n">index_col</span><span class="p">)</span>

    <span class="n">cur</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
    <span class="k">return</span> <span class="n">df</span></div>



</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>